package ar.rulosoft.mimanganu.servers;

import android.text.Html;

import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import ar.rulosoft.mimanganu.R;
import ar.rulosoft.mimanganu.componentes.Chapter;
import ar.rulosoft.mimanganu.componentes.Manga;
import ar.rulosoft.navegadores.Navegador;

public class SubManga extends ServerBase {

    public SubManga() {
        setServerID(SUBMANGA);
        setIcon(R.drawable.submanga_icon);
        this.setServerName("SubManga");
        setFlag(R.drawable.flag_esp);
    }

    @Override
    public ArrayList<Manga> getMangas() throws Exception {
        // <td><a href="(http://submanga.com/.+?)".+?</b>(.+?)<
        ArrayList<Manga> mangas = new ArrayList<>();
        Navegador nav = new Navegador();
        String source = nav.get("http://submanga.com/series/n");
        Pattern p = Pattern.compile("<td><a href=\"(http://submanga.com/.+?)\".+?</b>(.+?)<");
        Matcher m = p.matcher(source);
        while (m.find()) {
            String name = m.group(2);
            if (name.contains("") && name.contains("") && name.contains("") && name.contains("")) {
                mangas.add(new Manga(SUBMANGA, name, m.group(1), false));
            }
        }
        return mangas;
    }

    @Override
    public ArrayList<Manga> search(String term) throws Exception {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void loadChapters(Manga manga, boolean forceReload) throws Exception {
        if (manga.getChapters().size() == 0 || forceReload) {
            Pattern p;
            Matcher m;
            String data = new Navegador().get((manga.getPath() + "/completa"));
            p = Pattern.compile("<tr><td><a href=\"(http://submanga.com/.+?)\">(.+?)</td>");
            m = p.matcher(data);

            while (m.find()) {
                String web = "http://submanga.com/c/" + m.group(1).substring(m.group(1).lastIndexOf("/"));
                Chapter mc = new Chapter(Html.fromHtml(m.group(2)).toString(), web);
                mc.addChapterFirst(manga);
            }
        }
    }

    @Override
    public void loadMangaInformation(Manga manga, boolean forceReload) throws Exception {
        Pattern p;
        Matcher m;
        String data = new Navegador().get((manga.getPath()));

        p = Pattern.compile("</h1><img src=\"(http://.+?)\"/><br />(.+?)</div>");
        m = p.matcher(data);

        if (m.find()) {
            manga.setImages(m.group(1));
            manga.setSinopsis(Html.fromHtml(m.group(2)).toString());
        } else {
            manga.setSinopsis("Sin sinopsis.");
        }
    }

    @Override
    public String getPagesNumber(Chapter c, int page) {
        return c.getPath() + "/" + page;
    }

    @Override
    public String getImageFrom(Chapter c, int page) throws Exception {
        //if (c.getExtra() == null || c.getExtra().length() < 2) {
        String data;
        data = new Navegador().get(this.getPagesNumber(c, page));
        return getFirstMacthDefault("<img src=\"(http://.+?)\"", data, null);
        //} else {
        //	return (c.getExtra().split("|")[pagina]);
        //}
    }

    @Override
    public void chapterInit(Chapter c) throws Exception {
        String pagina;
        int i = 1;
        String extra = "";
        while ((pagina = getImageFrom(c, i)) != null) {
            extra = extra + "|" + pagina;
            i++;
        }
        c.setExtra(extra);
        i--;
        c.setPages(i);
    }

    @Override
    public ArrayList<Manga> getMangasFiltered(int categorie, int order, int pageNumber) throws Exception {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String[] getCategories() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String[] getOrders() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public boolean hasList() {
        return true;
    }

    @Override
    public boolean hasVisualNavegation() {
        return false;
    }

}
